#!/usr/bin/perl 

use LWP::Simple;  
use Archive::Extract;
use File::Copy;

# Vérifier que IO::Uncompress::Bunzip2 est installé pour éviter les erreur de décompression



# Ce fichier récupère l'ensemble des fichiers permettant de constituer la base
# Ces fichiers sont dits volatiles car à chaque fabrication de la base, ils sont censés être modifiés.
# Il faut vérifier point par point que les fichiers paramétrés plus loin n'ont pas été sujet à des changements d'emplacement ou surtout à de nouvelles versions.


#Partie à modifier et vérifier quant aux adresses et aux versions nouvelles 

$LexiqueURL="http://www.lexique.org/public/";
$LexiqueVersion="Lexique381.zip";
$LexiqueFile="Lexique381.txt";

$PrenomsURL="http://www.lexique.org/public/";
$PrenomsVersion="Prenoms100.zip";
$PrenomsFile="Prenoms.txt";

$VillesFranceURL="https://www.insee.fr/fr/statistiques/fichier/2114819/";
$VillesFranceFile="comsimp2016-txt.zip";
$FileVilleFrance="comsimp2016.txt" ;

$FortuneVersion="fortunes-fr-0.02.tar.gz";
$FortuneURL="http://www.fortunes-fr.org/fortunes-fr/" ;

$WikiquoteVersion="latest";
$WikiquoteURL="http://download.wikimedia.org/frwikiquote/$WikiquoteVersion";
$Wikiquotefile="frwikiquote-$WikiquoteVersion-pages-articles.xml.bz2";

$WiktionaryVersion="latest";
$WiktionaryURL="http://download.wikimedia.org/frwiktionary/$WiktionaryVersion";
$WiktionaryFile="frwiktionary-$WiktionaryVersion-pages-articles.xml.bz2";

#Partie récupération des données et renseignement du module config.pm
mkdir ("../Datas/volatiles/");
chdir ("../Datas/volatiles/");

open ( CONF,">../../bin/config.pm");

print CONF <<EOCF;
package config;;
use Exporter ;
\@ISA=('Exporter');
\@EXPORT_OK=('\$OpenOfficeDictFile','\$SourceDir','\$FortuneURL','\$Wikiquotefile','\$LexiqueFile','\$PrenomsFile','\$FileVilleFrance','\$WiktionaryFile');
EOCF

print CONF "\$SourceDir=\"../Datas\";\n";


print "Récupération de Lexique :$LexiqueURL$LexiqueVersion \n";
getstore ($LexiqueURL.$LexiqueVersion,$LexiqueVersion);
my $LexId = Archive::Extract->new( archive => $LexiqueVersion );
$LexId->extract();
print CONF "\$LexiqueFile=\"volatiles/$LexiqueFile\";\n";

print "Récupération des Prénoms :$PrenomsURL$PrenomsVersion \n";
getstore ($PrenomsURL.$PrenomsVersion,$PrenomsVersion);
my $PrenId = Archive::Extract->new( archive => $PrenomsVersion );
$PrenId->extract();
print CONF "\$PrenomsFile=\"volatiles/$PrenomsFile\";\n";

print "Récupération des Villes de France :$VillesFranceURL$VillesFranceFile \n";
getstore ($VillesFranceURL.$VillesFranceFile,$VillesFranceFile);
my $VFId = Archive::Extract->new( archive => $VillesFranceFile );
$VFId->extract();
print CONF "\$FileVilleFrance=\"volatiles/$FileVilleFrance\";\n";


print "Récupération de Fortune :$FortuneURL/$FortuneVersion \n";
getstore ($FortuneURL.$FortuneVersion,$FortuneVersion);
my $FortId = Archive::Extract->new( archive => $FortuneVersion );
$FortId->extract();
print CONF "\$FortuneURL=\"volatiles/fortunes-fr-0.02/data\";\n";

print "Récupération de Wikiquote : $WikiquoteURL/$Wikiquotefile\n";
getstore ("$WikiquoteURL/$Wikiquotefile",$Wikiquotefile);
my $WikiquoteId = Archive::Extract->new( archive => $Wikiquotefile );
$WikiquoteId->extract();
$Wikiquotefile=~s/\.bz2$//;
print CONF "\$Wikiquotefile=\"volatiles/$Wikiquotefile\";\n";

print "Récupération de Wiktionary : $WiktionaryURL/$WiktionaryFile\n";
getstore ("$WiktionaryURL/$WiktionaryFile",$WiktionaryFile);
my $WiktionId = Archive::Extract->new( archive => $WiktionaryFile);
$WiktionId->extract();
$WiktionaryFile=~s/\.bz2$//;
print CONF "\$WiktionaryFile=\"volatiles/$WiktionaryFile\";\n";



close (CONF);

