#ifndef GMZIP_H
#define GMZIP_H
#include <QString>
#include <QStringList>
#include <QObject>

class GMArchive : public QObject
{
    Q_OBJECT

public:
    enum ErrorNo { NoError, ErrorReadFile, ErrorReadFree,ErrorReadNextHeader,ErrorReadData, ErrorReadFormat};
    GMArchive(QString archivefilename, QObject *parent=0);
    ///
    /// \brief getFileNames return the file names of files in archive file
    /// \return  a QStringList containing the list
    ///
    QStringList getFileNames();
    ///
    /// \brief getFilesNumber : return the number of files contained in archive
    /// \return integer
    ///
    int getFilesNumber();
    ///
    /// \brief decompress decompress not an archive but a file like gz bz bz2
    /// \return : true if all is ok
    ///
    bool decompress();
    ///
    /// \brief getError : string with error
    /// \return  QString
    ///
    QString getError();
    ///
    /// \brief getErrorNum : return the num of error
    /// \return  int
    ///
    ErrorNo getErrorNum();

private:
    QString m_archive;
    QString m_password;
    QString m_dir;
    QString m_filename;
    QString m_error;
    ErrorNo m_errorNum;
    int m_filesNumber;
    struct archive *m_a;
    struct archive_entry *m_entry;
    int m_read;
    int copy_data(archive *a, archive *ext);
signals:
    void totalSize(QString,int);
    void readsize(QString,int);

};

#endif // ZIP_H
