#include "displaytable.h"
#include <QDebug>

DisplayTable::DisplayTable(QString tablename, QWidget *parent): QTableView(parent)
{
    this->setSortingEnabled(true);
    m_model= new QSqlTableModel(this);
    m_model->setTable(tablename);
    m_model->select();
    m_proxymodel = new QSortFilterProxyModel(this);
    m_proxymodel->setSourceModel(m_model);
    setModel(m_proxymodel);
}

void DisplayTable::resizeEvent(QResizeEvent *)
{
    int size=this->width()/m_proxymodel->columnCount();
    for ( int c=0;c<size;c++)   setColumnWidth(c,size);
}
