#include "codeeditor.h"
#include "phonemise.h"
#include "synonymes.h"
#include "correctionorthographique.h"
#include <QDebug>
#include <QtGui>
#include <QSettings>
#include <QTextCursor>
#include <QTextCharFormat>
#include <QSqlQuery>
#include <QAction>
#include <QMenu>

codeeditor::codeeditor(QWidget *parent) : QPlainTextEdit(parent)
 {
        QSettings settings;
         TypeAffichageDebutLigne=settings.value("AffichageDebutLigneEditeur").toInt();
         ZoneNumeroLigne = new zoneNumeroLigne(this);
          if (TypeAffichageDebutLigne == 2)
         {
                                connect(this,SIGNAL(cursorPositionChanged()),this,SLOT(AlerteCalculeNombreSyllabes()));
                                ListeNbSyl.clear();
                                 ListeNbSylText.clear();
                                MaxPhoneme=0;
                                NoLigneChangee=0;
                                LigneChangee="";

          }
          if (TypeAffichageDebutLigne > 0)
          {
          connect(this, SIGNAL(blockCountChanged(int)), this, SLOT(NumeroLigne(int)));
          connect(this, SIGNAL(updateRequest(const QRect &, int)), this, SLOT(MiseAjourNumeroLigne(const QRect &, int)));
          NumeroLigne(0);
          }
        // connect ( this->document(),SIGNAL(cursorPositionChanged(const QTextCursor &)),this, SLOT(ControleOrthographe(const QTextCursor &)));

 }

void codeeditor::ReConfigure ()
{
    QString sauve=this->document()->toPlainText();
    QSettings settings;
    TypeAffichageDebutLigne=settings.value("AffichageDebutLigneEditeur").toInt();
    disconnect(this,SIGNAL(blockCountChanged(int)));
    disconnect(this,SIGNAL(updateRequest(QRect,int)));
    disconnect(this,SIGNAL(cursorPositionChanged()));
    //delete( ZoneNumeroLigne);
    //ZoneNumeroLigne = new zoneNumeroLigne(this);
    if (TypeAffichageDebutLigne == 2)
   {
                          connect(this,SIGNAL(cursorPositionChanged()),this,SLOT(AlerteCalculeNombreSyllabes()));
                          ListeNbSyl.clear();
                           ListeNbSylText.clear();
                          MaxPhoneme=0;
                          NoLigneChangee=0;
                          LigneChangee="";

    }
    if (TypeAffichageDebutLigne > 0)
    {
    connect(this, SIGNAL(blockCountChanged(int)), this, SLOT(NumeroLigne(int)));
    connect(this, SIGNAL(updateRequest(const QRect &, int)), this, SLOT(MiseAjourNumeroLigne(const QRect &, int)));
    NumeroLigne(0);
    }
    this->Clear();
    this->SetPlainText(sauve);

}

void codeeditor::ActionMenu ( QAction *action)
{
    QString mot;
    QRegExp reg("«(.*)»");

    if ( action->text().contains(reg))
    {
        mot=reg.cap(1) ;
    }
    if ( action->text().contains("rimes") )
    {
     emit AskRime ( mot);
    }
    else if ( action->text().contains("définition"))
    {
        emit AskDefinition(mot);
    }
    else if ( action->text().contains("citation"))
    {
        emit AskCitation ( mot);
    }
    else if ( action->text().contains("conjugaison"))
    {
        emit AskConjugaison ( mot);
    }
    else if ( action->text().contains("Corriger"))
    {
         m_cursor.select(QTextCursor::WordUnderCursor);
         m_cursor.removeSelectedText();
         m_cursor.insertText(mot);
    }

}

void codeeditor::contextMenuEvent(QContextMenuEvent *event)
{

    m_menu = createStandardContextMenu();
    m_cursor=this->cursorForPosition(event->pos());
    m_cursor.select(QTextCursor::WordUnderCursor);
    QString mot=m_cursor.selectedText();
    CorrectionOrthographique cor;
    if ( ! cor.MotFauteOrthographe(mot) )
    {
        bool verbe = false ;
        QSqlQuery query("SELECT cgram FROM dico WHERE ( ortho='"+mot+"')");
        while ( query.next()){if ( query.value(0).toString()=="VER") verbe=true; }
        QAction *action0=new QAction("Synonyme de «"+mot+"»",this);
        QAction *action1 = new QAction("Chercher les rimes avec «"+mot+"»",this) ;
        QAction *action2 = new QAction("Chercher la définition de «"+mot+"»",this) ;
        QAction *action3 = new QAction("Chercher des citations contenant «"+mot+"»",this) ;
        QAction *action4;
        action4=action3;// pour éviter un warning
        if ( verbe ) { action4= new QAction("Afficher la conjugaison de «"+mot+"»",this) ;}
        QAction *separateur = new QAction (this);
        separateur->setSeparator(true);
        m_menu->insertAction(m_menu->actions().at(0),action0);
        QMenu *synmenu = new QMenu("Synonyme de «"+mot+"»",this);
        QSqlQuery syn("SELECT ortho,cgram,lemme,genre,nombre FROM dico WHERE ortho='"+mot+"'");
        syn.next();
        synonymes Syn;
        QStringList liste=Syn.ListeSynonymes(syn.value(0).toString(),
        syn.value(1).toString(),
        syn.value(2).toString(),
        syn.value(3).toString(),
        syn.value(4).toString());
        foreach ( QString act,  liste) synmenu->addAction(act);
        m_menu->insertMenu(action0,synmenu);
        m_menu->insertAction(m_menu->actions().at(1),action1);
        m_menu->insertAction(m_menu->actions().at(2),action2);
        m_menu->insertAction(m_menu->actions().at(3),action3);
        int i = 4;
        if ( verbe ) {m_menu->insertAction(m_menu->actions().at(4),action4); i=5; }

        m_menu->insertAction(m_menu->actions().at(i),separateur);

   }
    else
    {
       QStringList list= cor.MotsApprochant(mot);
       foreach ( QString l, list)
        {
            QAction *action=  new QAction ("Corriger par «"+l+"»",m_menu);
            m_menu->insertAction(m_menu->actions().at(0),action);
        }

    }
    connect ( m_menu,SIGNAL(triggered(QAction*)),this,SLOT(ActionMenu(QAction*)));
    m_menu->exec(event->globalPos());
}

void codeeditor::Clear( )
{
ListeNbSyl.clear();
ListeNbSylText.clear();
MaxPhoneme=0;
NoLigneChangee=0;
LigneChangee="";
this->clear();
}

void codeeditor::SetPlainText( QString  text)
{
        this->setPlainText(text);
        if (TypeAffichageDebutLigne == 2)
                {
                        CalculeNombreSyllabes();
                        NumeroLigne(0);
                }
}

void codeeditor::AlerteCalculeNombreSyllabes()
{
        if ( NoLigneChangee!=this->textCursor().blockNumber())
                {

                        phonemise ph;
                        //ph.SetDebug(15);
                        ph.PhraseDecoupee.clear();
                        ph.DecoupePhrase(LigneChangee);

                         int NbSyllabes=0;
                         foreach ( QString mot, ph.PhraseDecoupee)
                          {

                                                   QString m= ph.Text2Phoneme(mot);
                                                   NbSyllabes+=ph.NbSyllabe(m);
                          }

                        if ( NbSyllabes > MaxPhoneme ) MaxPhoneme=NbSyllabes ;
                        ListeNbSylText[LigneChangee]=NbSyllabes;
                        ListeNbSyl.clear();
                        QString Blocks=this->toPlainText();
                        QStringList Lignes=Blocks.split('\n');
                        NbSyllabes=0;
                        foreach ( QString ligne,Lignes)
                        {
                          if ( ListeNbSylText.keys().contains(ligne))
                                  ListeNbSyl.append(ListeNbSylText.value(ligne));
                          else
                          {
                          ph.PhraseDecoupee.clear();
                          ph.DecoupePhrase(ligne);

                          int noligne=0;
                          foreach ( QString mot, ph.PhraseDecoupee)
                           {
                                                        QString m= ph.Text2Phoneme(mot);
                                                        NbSyllabes+=ph.NbSyllabe(m);
                                                        if ( NbSyllabes > MaxPhoneme ) MaxPhoneme=NbSyllabes ;
                           }
                          ListeNbSyl.append(NbSyllabes);
                          ListeNbSylText[ligne]=NbSyllabes;
                          noligne++;
                          }
                        }

                        }
        NoLigneChangee=this->textCursor().blockNumber();
        LigneChangee=this->textCursor().block().text();
}

void codeeditor::CalculeNombreSyllabes()
{
        phonemise ph;
        MaxPhoneme=0;
        int noligne=0;
        QString Blocks=this->toPlainText();
        QStringList Lignes=Blocks.split('\n');
        ListeNbSyl.clear();
        ListeNbSylText.clear();
        ListePhoneme.clear();
        foreach ( QString ligne,Lignes)
        {
          int NbSyllabes=0;
          ph.PhraseDecoupee.clear();
          ph.DecoupePhrase(ligne);
          foreach ( QString mot, ph.PhraseDecoupee)
           {

                        QString m= ph.Text2Phoneme(mot);
                        ListePhoneme.append(m);
                                                NbSyllabes+=ph.NbSyllabe(m);
                                                if ( NbSyllabes > MaxPhoneme ) MaxPhoneme=NbSyllabes ;
           }

                  ListeNbSyl.append(NbSyllabes);
                  ListeNbSylText[ligne]=NbSyllabes;
          noligne++;
        }
}




 int codeeditor::LargeurZoneNumeroLigne()
 {
         int digits = 1;
         int max ;

         if (TypeAffichageDebutLigne == 2) { max = qMax(1, MaxPhoneme); }
         else if (TypeAffichageDebutLigne ==  1 )max = qMax(1, blockCount());
                 else max=0;
         while (max >= 10) {
                 max /= 10;
                 ++digits;
         }
         int space = 3 + fontMetrics().width(QLatin1Char('9')) * digits;
         return space;
 }



 void codeeditor::NumeroLigne(int noligne)
 {

     Q_UNUSED (noligne);

         setViewportMargins(LargeurZoneNumeroLigne(), 0, 0, 0);
 }



 void codeeditor::MiseAjourNumeroLigne(const QRect &rect, int dy)
 {
         if (dy)
                 ZoneNumeroLigne->scroll(0, dy);
         else
                 ZoneNumeroLigne->update(0, rect.y(), ZoneNumeroLigne->width(), rect.height());

         if (rect.contains(viewport()->rect()))
                 NumeroLigne(0);
 }



 void codeeditor::resizeEvent(QResizeEvent *e)
 {
         QPlainTextEdit::resizeEvent(e);

         QRect cr = contentsRect();
         ZoneNumeroLigne->setGeometry(QRect(cr.left(), cr.top(), LargeurZoneNumeroLigne(), cr.height()));
 }



 void codeeditor::ZoneNumeroLignePaintEvent(QPaintEvent *event)
 {
        if (TypeAffichageDebutLigne > 0)
         {
         QPainter painter(ZoneNumeroLigne);
         painter.fillRect(event->rect(), Qt::lightGray);

         QTextBlock block = firstVisibleBlock();
         int blockNumber = block.blockNumber();
         int top = (int) blockBoundingGeometry(block).translated(contentOffset()).top();
         int bottom = top + (int) blockBoundingRect(block).height();
         while (block.isValid() && top <= event->rect().bottom()) {
                                // if (block.isVisible() && bottom >= event->rect().top()) {
                         if (block.isVisible() ) {
                                                 QString number;
                         if ( TypeAffichageDebutLigne == 1 )
                          number= QString::number(blockNumber + 1);
                         else if ( TypeAffichageDebutLigne == 2 )
                                                  {
                                                        if ( blockNumber>= ListeNbSyl.size()) number="?";
                                                        else number=QString::number(ListeNbSyl.at(blockNumber) );
                                                  }
                         painter.setPen(Qt::black);
                         painter.drawText(0, top, ZoneNumeroLigne->width(), fontMetrics().height(),
                                                          Qt::AlignRight, number);
                 }

                 block = block.next();
                 top = bottom;
                 bottom = top + (int) blockBoundingRect(block).height();
                 ++blockNumber;
         }
  }
 }


 void codeeditor::ControleOrthographe( const QTextCursor & cur)
 {
     QTextCursor cursor=cur;
     cursor.select(QTextCursor::WordUnderCursor);
     QString mot=cursor.selectedText();
     CorrectionOrthographique cor;
     QTextCharFormat format ;
     if ( cor.MotFauteOrthographe(mot) ) {
         format.setUnderlineStyle(QTextCharFormat::SingleUnderline);
     }
     else{
         format.setUnderlineStyle(QTextCharFormat::NoUnderline);
     }
     cursor.setCharFormat(format);
  }
