/***************************************************************************
 *   Copyright (C) 2007-2008-2009 by Gilles Maire                          *
 *   Gilles@lesjetesdelencre.com                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <QFileDialog>
#include <QSettings>
#include <QVariant>
#include <QtSql>
#include <QMessageBox>
#include <QProcess>
#include <QDir>
#include <QIcon>

#include "configuration.h"
#include "feuillestyle.h"
#include "qdictionnaire.h"
#include "lanquage.h"

configuration::configuration ( QWidget* parent )
                : QDialog ( parent)
{
        setupUi ( this );
        tabWidget->setCurrentIndex ( 0 );
#ifdef  Q_OS_MAC
LabelEmplacement->setHidden(true);
EntreeEmplacement->setHidden(true);
selecteurfichierconf->setHidden(true);
#endif
        QSettings settings;

                EntreeEmplacement->insert(settings.value("NomBase").toString());
                m_basename=settings.value("NomBase").toString();
                RichesseRimeDefaut->setValue(settings.value("RichesseRimeDefaut").toInt());
                spinBoxNombreDerniersMotsEntres->setValue(settings.value("NombreDerniersMotsEntres").toInt());
                PoliceDefaut->setEditText(settings.value("PoliceDefaut").toString());
                TaillePoliceDefaut->setValue(settings.value("TaillePoliceDefaut").toInt());
                if ( settings.value("SauvegarderAvantQuitter")==1 ) Sauvegarderavantquitter->setCheckState(Qt::Checked);
                else Sauvegarderavantquitter->setCheckState(Qt::Unchecked);
                if ( settings.value("AfficherLieux")==1) this->checkBoxAfficherLieux->setCheckState(Qt::Checked);
                else this->checkBoxAfficherLieux->setCheckState(Qt::Unchecked);
                if ( settings.value("AfficherPrenoms")==1) this->checkBoxAfficherPrenoms->setCheckState(Qt::Checked);
                else this->checkBoxAfficherPrenoms->setCheckState(Qt::Unchecked);
                if ( settings.value("AfficherAdjectifs")==1) this->checkBoxAfficherAdjectifs->setCheckState(Qt::Checked);
                else this->checkBoxAfficherAdjectifs->setCheckState(Qt::Unchecked);
                if ( settings.value("AfficherVerbes")==1) this->checkBoxAfficherVerbes->setCheckState(Qt::Checked);
                else this->checkBoxAfficherVerbes->setCheckState(Qt::Unchecked);
                if ( settings.value("AfficherNoms")==1) this->checkBoxAfficherNoms->setCheckState(Qt::Checked);
                else this->checkBoxAfficherNoms->setCheckState(Qt::Unchecked);
                if ( settings.value("AfficherSigles")==1) this->checkBoxAfficherSigles->setCheckState(Qt::Checked);
                else this->checkBoxAfficherSigles->setCheckState(Qt::Unchecked);
                if (settings.value("LancerIconifie").toBool()) checkBoxLancementIconifie->setCheckState(Qt::Checked);
                else checkBoxLancementIconifie->setCheckState(Qt::Unchecked);
                if (settings.value("OpenLastOpenFile").toBool()) checkBoxOpenLatFileOpen->setCheckState(Qt::Checked);
                else checkBoxOpenLatFileOpen->setCheckState(Qt::Unchecked);

                if (settings.value("WindowGeometry/SaveMainWindowGeometry").toBool() )
                    checkBoxSaveWindowGeometry->setCheckState(Qt::PartiallyChecked);
                else checkBoxSaveWindowGeometry->setCheckState(Qt::Unchecked);

                Lanquage l;
                l.makeComboBox(this->comboBoxLanguage,
                               settings.value("Language").toString());




                DebutLigneEditeurcomboBox->setCurrentIndex(settings.value("AffichageDebutLigneEditeur").toInt());
                if ( settings.value("Mode")== qdictionnaire::Onglet::Citation ) radioButtonModeCitation->setChecked(true);
                else if ( settings.value("Mode")== qdictionnaire::Onglet::Edition ) radioButtonModeEdition->setChecked(true);
                else radioButtonModeDefinition->setChecked(true);

                connect (Enregistrer, SIGNAL ( clicked()), this, SLOT( enregistrer() )) ;
                connect ( selecteurfichierconf , SIGNAL (clicked() ), this, SLOT (configurationfile()));


                //QString StyleFile=settings.value("NomBase").toString();
                m_listStyle <<"Aucun"<<QString::fromUtf8("Élégant")<<"Plage";

                m_listDataStyle <<"Aucun"<<"Elegant"<<"Plage";
                int i;
                for ( i=0; i<3; i++)
                comboBoxFeuilleStyle->addItem(m_listStyle.at(i),m_listDataStyle.at(i));
                comboBoxFeuilleStyle->setCurrentIndex(comboBoxFeuilleStyle->findData(settings.value("Style").toString()));
                comboBoxFeuilleStyle->view()->setMinimumWidth(9*settings.value("TaillePoliceDefaut").toInt());
                connect ( comboBoxFeuilleStyle,SIGNAL(currentIndexChanged(int)),this,SLOT(ChangeStyle(int)));
                connect (PoliceDefaut,SIGNAL(currentIndexChanged(QString)),this,SLOT(ChangeFont(QString)));
                connect (TaillePoliceDefaut,SIGNAL(valueChanged(int)),this,SLOT(ChangeTailleFont(int)));
                connect(comboBoxLanguage,SIGNAL(currentIndexChanged(int)),this,SLOT(ChangeLanguage(int)));

}

void configuration::ChangeStyle(int style)
{
    QSettings settings;
    settings.setValue("Style",m_listDataStyle.at(style));
    settings.sync();
    feuillestyle feuille(m_listDataStyle.at(style));
    this->setStyleSheet(feuille.GetStyle());

}

void configuration::ChangeFont(QString )
{
    QSettings settings;
    settings.setValue("PoliceDefaut",PoliceDefaut->currentText());
    //this->setFont());
    qApp->setFont(QFont(settings.value("PoliceDefaut").toString(),settings.value("TaillePoliceDefaut").toInt()));


}

void configuration::ChangeTailleFont(int )
{
    QSettings settings;
    settings.setValue("TaillePoliceDefaut",TaillePoliceDefaut->text());
    qApp->setFont(QFont(settings.value("PoliceDefaut").toString(),settings.value("TaillePoliceDefaut").toInt()));

}

/*$SPECIALIZATION$*/

void configuration::enregistrer(){
bool relaunch=false;
QSettings settings;
#ifndef  Q_OS_MAC
settings.setValue ("NomBase",EntreeEmplacement->text() );
if ( m_basename  != EntreeEmplacement->text()) relaunch=true;
#endif
settings.setValue ("RichesseRimeDefaut",RichesseRimeDefaut->value() );
settings.setValue("NombreDerniersMotsEntres",spinBoxNombreDerniersMotsEntres->value());
settings.setValue("AffichageDebutLigneEditeur",DebutLigneEditeurcomboBox->currentIndex());
if ( this->checkBoxAfficherPrenoms->isChecked() )   settings.setValue("AfficherPrenoms",1);
else settings.setValue("AfficherPrenoms",0);
if ( this->checkBoxAfficherLieux->isChecked()) settings.setValue("AfficherLieux",1);
else settings.setValue("AfficherLieux",0);
if ( this->checkBoxAfficherAdjectifs->isChecked() )   settings.setValue("AfficherAdjectifs",1);
else settings.setValue("AfficherAdjectifs",0);
if ( this->checkBoxAfficherVerbes->isChecked()) settings.setValue("AfficherVerbes",1);
else settings.setValue("AfficherVerbes",0);
if ( this->checkBoxAfficherNoms->isChecked()) settings.setValue("AfficherNoms",1);
else settings.setValue("AfficherNoms",0);
if ( this->checkBoxAfficherSigles->isChecked()) settings.setValue("AfficherSigles",1);
else settings.setValue("AfficherSigles",0);

if ( Sauvegarderavantquitter->checkState()==Qt::Checked) settings.setValue("SauvegarderAvantQuitter",1);
else settings.setValue("SauvegarderAvantQuitter",0);
if ( radioButtonModeCitation->isChecked() ) settings.setValue("Mode",qdictionnaire::Onglet::Citation);
else if ( radioButtonModeEdition->isChecked() ) settings.setValue("Mode",qdictionnaire::Onglet::Edition);
else settings.setValue("Mode",qdictionnaire::Onglet::Definition);
settings.setValue("LancerIconifie",checkBoxLancementIconifie->isChecked() );
if ( checkBoxSaveWindowGeometry->checkState()== Qt::Unchecked )
    settings.setValue("WindowGeometry/SaveMainWindowGeometry",false);
else
    settings.setValue("WindowGeometry/SaveMainWindowGeometry",true);
if (checkBoxSaveWindowGeometry->checkState()==Qt::Checked) emit SaveGeometry();
emit ChangeLanguages(m_systemtranslator,m_applicationtranslator);
settings.setValue("OpenLastFileOpen",checkBoxOpenLatFileOpen->isChecked());
Lanquage l;
settings.setValue("Language",l.getCodeLang(comboBoxLanguage->currentIndex()));
settings.sync();
if ( relaunch)
{
dicodb.close();
QString program = AppPath;
QStringList arguments;
arguments << MotCherche;
QProcess *myProcess = new QProcess();
myProcess->startDetached(program, arguments);
exit(0);
}
else
{
emit (ReloadConfig());
this->close();
}


}

void configuration::configurationfile (){
    QString dir=EntreeEmplacement->text();
    if ( dir.isEmpty() ) dir=QDir::homePath();
    EntreeEmplacement->setText ( QFileDialog::getOpenFileName(this, "Ouvrir le fichier",dir,"*.db"));
}

configuration::~configuration()
{
}

void configuration::setTranslator(QTranslator *systemtranslator, QTranslator *applicationtranslator)
{
    m_systemtranslator=systemtranslator;
    m_applicationtranslator=applicationtranslator;
}

void configuration::ChangeLanguage(int  indexlang)
{
   Lanquage l;
   qApp->removeTranslator(m_applicationtranslator);
   qApp->removeTranslator(m_systemtranslator);
   QString langs=l.getSystemtr(indexlang);
   QString langa=l.getApptr(indexlang);
   qWarning()<<langs<<langa;
   m_applicationtranslator->load(langa);
   m_systemtranslator->load(langs);
   qApp->installTranslator(m_applicationtranslator);
   qApp->installTranslator(m_systemtranslator);
   retranslateUi(this);

}

int configuration::LanguageIndex(QString lang)
{
    int index=0;
    QSettings s;
    if (s.value("Language").toString().isEmpty()) s.setValue("Language","fr");
    while (index < comboBoxLanguage->count())
    {
        if ( comboBoxLanguage->itemIcon(index).name() == QString("%1.png").arg(lang)) break;
        index++;
    }
    return index;
}
