#include "dialogsysteminfo.h"
#include "ui_dialogsysteminfo.h"
#include <QSettings>
#include "version.h"

DialogSystemInfo::DialogSystemInfo(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::DialogSystemInfo)
{
    ui->setupUi(this);
}

void DialogSystemInfo::setInfo(QString basename)
{
    QSettings s;
    ui->lineEditBD->setText(basename);
    ui->lineEditConfig->setText(s.fileName());
    ui->lineEditProgram->setText(qApp->applicationFilePath());
    ui->labelFormatConfig->setText(format(s.format()));
    QStringList l=qApp->arguments();
    l.removeFirst();
    ui->lineEditArgument->setText(l.join(" "));
    ui->lineEditSHA1->setText(QString("%1").arg(GIT));
    ui->lineEditDateCompilation->setText(QString("%1").arg(DATEBUILD));
    ui->lineEditVersion->setText(QString("%1").arg(VERSIONWORK));
    ui->lineEditVersionQt->setText(QString("%1").arg(QT_VERSION_STR));

}

DialogSystemInfo::~DialogSystemInfo()
{
    delete ui;
}

QString DialogSystemInfo::format(QSettings::Format format)
{
    if ( format == QSettings::NativeFormat ) return ( "natif");
    else if ( format == QSettings::IniFormat ) return ("INI");
    else return ("Inconnu");
}
