#include "lanquage.h"


#include <QFileInfo>
#include <QDir>
#include <QDebug>

Lanquage::Lanquage()
{
    QDir dir(":/");
    foreach ( QFileInfo fi, dir.entryInfoList() )
    {
        QString filename=fi.filePath();
        QRegExp Lang("^:/Lang_([^_]+)_(.*)");
        if ( filename.contains(Lang))
        {
            QString codelang=Lang.cap(1);
            QString langname=Lang.cap(2);
            QMap <QString, QString> map;
            map["flag"]=QString("%1/images/%2.png").arg(filename,codelang);
            map["systemtr"]=QString("%1/qt_%2.qm").arg(filename,codelang);
            map["apptr"]=QString("%1/%2.qm").arg(filename,codelang);
            map["name"]=langname;
            map["code"]=codelang;
            m_langinfo<<map;
        }
    }

}

int Lanquage::count()
{
  return m_langinfo.count();
}

QString Lanquage::getFlag(int i)
{
    return m_langinfo[i]["flag"];
}

QString Lanquage::getFlag(QString codelang)
{
    return getFlag(number(codelang));
}

QString Lanquage::getSystemtr(int i)
{
    return m_langinfo[i]["systemtr"];
}

QString Lanquage::getSystemtr(QString codelang)
{
    return getSystemtr(number(codelang));
}

QString Lanquage::getApptr(int i)
{
    return m_langinfo[i]["apptr"];
}

QString Lanquage::getApptr(QString codelang)
{
    return getApptr(number(codelang));
}

QString Lanquage::getName(int i)
{
    return m_langinfo[i]["name"];
}

QString Lanquage::getName(QString codelang)
{
    return getName(number(codelang));
}

QString Lanquage::getCodeLang(int i)
{
    return m_langinfo[i]["code"];
}


void Lanquage::makeComboBox(QComboBox *cb, QString defaultcode)
{
    cb->clear();
    int defaultindex=0;
    for ( int i=0; i<count(); i++)
    {
       cb->addItem(QIcon(getFlag(i)),getName(i),QVariant(getCodeLang(i)));
       if (getCodeLang(i) == defaultcode ) defaultindex=i;
    }
    cb->setCurrentIndex(defaultindex);
}

int Lanquage::number(QString codelang)
{
    for ( int i=0; i<count(); i++)
    {
        if ( getCodeLang(i)== codelang) return i;
    }
    return 0;
}
