#ifndef PHONEMISE_H
#define PHONEMISE_H
#include <QString>
#include <QStringList>
#include <QHash>

class phonemise {

private:

QString TraiteA ( QString );
QString TraiteB ( QString );
QString TraiteC ( QString );
QString TraiteD ( QString );
QString TraiteE ( QString );
QString TraiteF ( QString );
QString TraiteG ( QString );
QString TraiteH  ( QString );
QString TraiteI ( QString );
QString TraiteJ ( QString );
QString TraiteK ( QString );
QString TraiteL  ( QString );
QString TraiteM  ( QString );
QString TraiteN  ( QString );
QString TraiteO ( QString );
QString TraiteP  ( QString );
QString TraiteQ ( QString );
QString TraiteR ( QString );
QString TraiteS ( QString );
QString TraiteT ( QString );
QString TraiteU ( QString );
QString TraiteV ( QString );
QString TraiteW ( QString );
QString TraiteX ( QString );
QString TraiteY ( QString );
QString TraiteZ ( QString );
QString FinMuette ( QString );
QString TraiteTrema ( QString );
QString ChangeLettresFictives ( QString );
QString TraiteDoubleConsonne ( QString );
QString SupprimePonctuation  ( QString );
QString Exceptions  ( QString );
QString Sigle  ( QString );
QString PhonemiseAvecRacine  ( QString );
QString PhonemiseMot  ( QString );
QString Phonemise  ( QString );
QString MinusculeSaufSigle( QString mot);
QHash <QString, QString> Exception ;
int debug ;
void Debug(int,QString);
QString Minuscule (QString);
QString ExceptionMotPrecedent( QString chaine);
QString ExceptionMotSuivant( QString chaine);


public:
///
/// \brief phonemise cette classe permet de phonémiser un mot ou un groupe de mots en phonèmes
///
    phonemise();
    ///
    /// \brief Text2Phoneme
    /// \param texte à phonémiser
    /// \return le texte phonémisé
    ///
    QString Text2Phoneme(QString texte);
    ///
    /// \brief DecoupePhrase  découpe une phrase en prenant compte des voyelles en début de mot qui doivent  être liées.
    /// amicale enfant => amicalenfant
    /// oiseau hautain => oiseau hautain
    /// sacrés livres => sacrés livres
    /// sacrés enfants => sacrésenfants
    /// sacré enfant => sacré enfant
    /// \param mots la phrase
    ///
    void DecoupePhrase(QString phrase);
    ///
    /// \brief SetDebug provoque l'affichage de trace
    /// \param niveau un niveau de 0 à 255
    ///
    void SetDebug(int niveau);
    ///
    /// \brief UnsetDebug annule l'affichage de trace
    ///
    void UnsetDebug();
    ///
    /// \brief NbSyllabe affiche le nombre de syllabes d'un mot
    /// \param chaine est le mot à analyser
    /// \return le nombre de syllabes
    ///
    int NbSyllabe(QString nb);
    QStringList PhraseDecoupee;
    ///
    /// \brief PhonemiseBlock phonémise une phrase
    /// \param phrase la phrase à phonémiser
    /// \return la phonémisation
    ///
    QString PhonemiseBlock(QString phrase);
};
#endif
